package com.shtrihm.equipment.jpos.tests.scale;

import pa.tools.Tools;
import jpos.JposException;
import jpos.events.DataEvent;
import jpos.events.DataListener;


public class ScaleTests implements DataListener {	
	
	private String[] m_args = null;
	
	public ScaleTests(String[] args) {
		m_args = args;
	}
	
	public void test() {
		
		System.out.println(com.shtrihm.equipment.jpos.Lib.NAME + " v" +
						   com.shtrihm.equipment.jpos.Lib.getTextVersion());
		
		System.out.println(pa.equipment.Lib.NAME + " v" +
						   pa.equipment.Lib.getTextVersion());
		
		
		jpos.Scale scale = new jpos.Scale();
		scale.addDataListener(this);
		
		try {
			scale.open("ShtrihmScalePos2");
		} catch (JposException e) {
			e.printStackTrace();
			return;
		}
		
		try {
			scale.claim(1000);
		} catch (JposException e) {
			e.printStackTrace();
			return;
		}
		
		try {
			scale.setDeviceEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
			return;
		}
		
		int[] weight = new int[1];
		
		/*try {
			scale.setAsyncMode(true);
		} catch (JposException e) {
			e.printStackTrace();
			return;
		}
		
		System.out.println("Reading Weight (async)...");
		try {
			scale.setDataEventEnabled(false);
		} catch (JposException e) {
			e.printStackTrace();
		}
		try {
			scale.readWeight(weight, 250);
		} catch (JposException e) {
			e.printStackTrace();
		}	
		System.out.println("Completed.");
		try {
			scale.setDataEventEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
		}
		
		try { Thread.sleep(500); } catch (InterruptedException e) { e.printStackTrace();	}
		*/
		
		try {
			scale.setAsyncMode(false);
		} catch (JposException e) {
			e.printStackTrace();
			return;
		}
		System.out.println("Reading Weight...");
		try {
			for (int i = 0; i < 10; i++) {
				//Every 1 second
				scale.setTareWeight(0);
				scale.readWeight(weight, 250);
				System.out.println("Weight (sync): " + (float)weight[0] / 1000.0f + " kg.");
				try { Thread.sleep(1000); } catch (InterruptedException e) { e.printStackTrace();	}
			}
		} catch (JposException e) {
			e.printStackTrace();
		}
		
		try {
			scale.setDeviceEnabled(false);
		} catch (JposException e) {
			e.printStackTrace();
		}
		try {
			scale.release();
		} catch (JposException e) {
			e.printStackTrace();
		}
		try {
			scale.close();
		} catch (JposException e) {
			e.printStackTrace();
		}
		
	}

	@Override
	public void dataOccurred(DataEvent event) {
		System.out.println("Weight (async): " + (float)event.getStatus() / 1000.0f + " kg.");

	}
	
	//static
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ScaleTests tests = new ScaleTests(args);
		tests.test();
	}

}
